//----------------------------------------------------------------------//
// NyanFi																//
//  LtH_/TufBNgI/Cuꗗ					//
//----------------------------------------------------------------------//
#include <vcl.h>
#pragma hdrstop
#include <tchar.h>
#include <memory>
#include <lm.h>
#include <Vcl.Clipbrd.hpp>
#include "UserFunc.h"
#include "Global.h"
#include "MainFrm.h"
#include "ShareDlg.h"

//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TNetShareDlg *NetShareDlg = NULL;

//---------------------------------------------------------------------------
__fastcall TNetShareDlg::TNetShareDlg(TComponent* Owner)
	: TForm(Owner)
{
	ComputerName = PathName = EmptyStr;
	isSelDir = isLibrary = false;
}
//---------------------------------------------------------------------------
void __fastcall TNetShareDlg::FormCreate(TObject *Sender)
{
	ListScrPanel = new UsrScrollPanel(ListPanel, ShareListBox, USCRPNL_FLAG_P_WP | USCRPNL_FLAG_L_WP);
}
//---------------------------------------------------------------------------
void __fastcall TNetShareDlg::FormShow(TObject *Sender)
{
	if (isSelDir)
		IniFile->LoadPosInfo(this, DialogCenter, isSelSub? "SelSub" : "SelDir");
	else if (isLibrary)
		IniFile->LoadPosInfo(this, DialogCenter, "Library");
	else
		IniFile->LoadPosInfo(this, DialogCenter);

	//
	TControl *cp = (TControl *)((CurListTag==0)? NyanFiForm->L_Panel : NyanFiForm->R_Panel);
	TPoint p = cp->ClientToScreen(cp->ClientRect.CenteredRect(BoundsRect).Location);
	Left = p.x;
	Top  = p.y;

	//͂ݏoC
	cp = (TControl *)NyanFiForm->ListPanel;
	TPoint p0 = cp->ClientToScreen(Point(0, 8));
	TPoint p1 = cp->ClientToScreen(Point(0, cp->Height - 8));
	if (Top < p0.y)			 	Top = p0.y;
	if ((Top + Height) > p1.y)	Top = p1.y - Height;

	set_StdListBox(ShareListBox);
	set_UsrScrPanel(ListScrPanel);

	PathTabControl->Visible = false;
	PathTabControl->Height = get_FontHeight(PathTabControl->Font, 8, 8) + 2;
	if (isSelDir && isSelSub) {
		PathTabControl->Tabs->Clear();
		TStringDynArray plst = split_path(PathName);
		for (int i=0; i<plst.Length; i++) PathTabControl->Tabs->Add(plst[i]);
		PathTabControl->Visible  = true;
		PathTabControl->TabIndex = PathTabControl->Tabs->Count - 1;
	}

	::PostMessage(Handle, WM_FORM_SHOWED, 0, 0);
}
//---------------------------------------------------------------------------
void __fastcall TNetShareDlg::WmFormShowed(TMessage &msg)
{
	//fBNg̑I
	if (isSelDir) {
		PathName = IncludeTrailingPathDelimiter(PathName);
		UpdatePathList(PathName);
	}
	//Cu
	else if (isLibrary) {
		Caption = "Cu";
		std::unique_ptr<TStringList> l_lst(new TStringList());
		get_files(LibraryPath, _T("*.library-ms"), l_lst.get());
		ShareListBox->Items->Assign(l_lst.get());
		ListBoxSetIndex(ShareListBox, 0);
	}
	//LtH_
	else {
		if (!ComputerName.IsEmpty() && !StartsStr("\\\\", ComputerName)) ComputerName.Insert("\\\\", 1);
		ComputerName = ExcludeTrailingPathDelimiter(ComputerName);
		UpdateShareList(ComputerName);
	}

	ListScrPanel->UpdateKnob();
}

//---------------------------------------------------------------------------
void __fastcall TNetShareDlg::FormClose(TObject *Sender, TCloseAction &Action)
{
	if (isSelDir)
		IniFile->SavePosInfo(this, isSelSub? "SelSub" : "SelDir");
	else if (isLibrary)
		IniFile->SavePosInfo(this, "Library");
	else
		IniFile->SavePosInfo(this);

	isSelDir = isSelSub = isLibrary = false;
}
//---------------------------------------------------------------------------
void __fastcall TNetShareDlg::FormDestroy(TObject *Sender)
{
	delete ListScrPanel;
}

//---------------------------------------------------------------------------
//LtH_ꗗ̍XV
//---------------------------------------------------------------------------
void __fastcall TNetShareDlg::UpdateShareList(UnicodeString cnam)
{
	cnam = ExcludeTrailingPathDelimiter(cnam);
	Caption = cnam;

	TListBox *lp = ShareListBox;
	lp->Clear();

	static PSHARE_INFO_1 p_si = NULL;
	DWORD entry_cnt, total_cnt;
	cursor_HourGlass();
	if (::NetShareEnum(cnam.c_str(), 1, (LPBYTE *)&p_si, MAX_PREFERRED_LENGTH, &entry_cnt, &total_cnt, NULL)==NERR_Success) {
		for (DWORD i=0; i<entry_cnt; i++) {
			if (p_si[i].shi1_type==STYPE_DISKTREE) {
				UnicodeString nnam = p_si[i].shi1_netname;
				if (!EndsStr("$", nnam)) lp->Items->Add(nnam);
			}
		}
	}
	if (p_si) ::NetApiBufferFree(p_si);
	cursor_Default();

	UnicodeString pnam = CurPathName;
	if (remove_top_s(pnam, "\\\\"))
		pnam = ExcludeTrailingPathDelimiter(get_tkn_r(pnam, "\\"));
	else
		pnam = EmptyStr;
	ListBoxSetIndex(lp, lp->Items->IndexOf(pnam));
}

//---------------------------------------------------------------------------
//fBNgꗗ̍XV
//---------------------------------------------------------------------------
void __fastcall TNetShareDlg::UpdatePathList(UnicodeString pnam)
{
	if (isSelSub) Caption = ExcludeTrailingPathDelimiter(pnam);

	pnam = IncludeTrailingPathDelimiter(pnam);
	std::unique_ptr<TStringList> d_lst(new TStringList());
	TSearchRec sr;
	if (FindFirst(cv_ex_filename(UAPP_T(pnam, "*")), faAnyFile, sr)==0) {
		do {
			if ((sr.Attr & faDirectory)==0) continue;
			if (!ShowHideAtr   && (sr.Attr & faHidden))  continue;
			if (!ShowSystemAtr && (sr.Attr & faSysFile)) continue;
			if (ContainsStr("..", sr.Name)) continue;
			d_lst->Add(pnam + sr.Name);
		} while(FindNext(sr)==0);
		FindClose(sr);
	}

	if (!is_root_dir(pnam) && !isSelSub) d_lst->Add(pnam + "..");
	d_lst->CustomSort(comp_NaturalOrder);

	TListBox *lp = ShareListBox;
	lp->Items->Assign(d_lst.get());
	ListBoxSetIndex(lp, lp->Items->IndexOf(ExcludeTrailingPathDelimiter(CurPathName)));
}

//---------------------------------------------------------------------------
void __fastcall TNetShareDlg::PathTabControlDrawTab(TCustomTabControl *Control, int TabIndex,
          const TRect &Rect, bool Active)
{
	TTabControl *tp = (TTabControl*)Control;
	TCanvas *cv = tp->Canvas;
	cv->Brush->Color = Active? scl_Highlight : scl_BtnFace;
	cv->Font->Color  = Active? scl_HighlightText : scl_WindowText;
	cv->FillRect(Rect);
	int yp = (Rect.Height() - cv->TextHeight("Q")) /2;
	cv->TextOut(Rect.Left + 2, yp, yen_to_slash(PathTabControl->Tabs->Strings[TabIndex]));
}
//---------------------------------------------------------------------------
void __fastcall TNetShareDlg::PathTabControlChange(TObject *Sender)
{
	int idx = PathTabControl->TabIndex;
	if (idx!=-1) {
		UnicodeString pnam;
		for (int i=0; i<PathTabControl->Tabs->Count && i<=idx; i++)
			pnam += PathTabControl->Tabs->Strings[i] + "\\";

		if (is_computer_name(pnam)) {
			isSelDir = isSelSub = false;
			ComputerName = ExcludeTrailingPathDelimiter(pnam);
			UpdateShareList(ComputerName);
		}
		else {
			isSelDir = isSelSub = true;
			UpdatePathList(pnam);
		}
	}
}

//---------------------------------------------------------------------------
//Xgڂ̕`
//---------------------------------------------------------------------------
void __fastcall TNetShareDlg::ShareListBoxDrawItem(TWinControl *Control, int Index,
		TRect &Rect, TOwnerDrawState State)
{
	TListBox *lp = (TListBox*)Control;
	TCanvas *cv = lp->Canvas;
	cv->Font->Assign(ListFont);
	cv->Brush->Color = col_bgList;
	cv->FillRect(Rect);

	int xp = Rect.Left + 2;
	int yp = Rect.Top + get_TopMargin2(cv);

	if (Index<10) {
		cv->Font->Color = col_fgList;
		cv->Font->Style = cv->Font->Style << fsUnderline;
		cv->TextOut(xp, yp, UnicodeString().sprintf(_T("%u"), (Index + 1)%10));
	}

	cv->Font->Style = cv->Font->Style >> fsUnderline;
	xp += get_CharWidth(cv, 2);

	UnicodeString lbuf = lp->Items->Strings[Index];

	if (isSelDir) {
		lbuf = ExtractFileName(lbuf);
	}
	else if (isLibrary) {
		//ACR
		if (ShowIcon) {
			draw_SmallIcon2(lbuf, cv, xp, std::max(yp + (cv->TextHeight("Q") - 16)/2, 0));
			xp += ScaledInt(20);
		}
		lbuf = get_base_name(lbuf);
	}

	//O
	cv->Font->Color = col_Folder;
	cv->TextOut(xp, yp, lbuf);

	//J[\
	draw_ListCursor2(lp, Rect, Index, State);
}

//---------------------------------------------------------------------------
void __fastcall TNetShareDlg::ShareListBoxKeyDown(TObject *Sender, WORD &Key, TShiftState Shift)
{
	TListBox *lp = (TListBox*)Sender;
	UnicodeString KeyStr = get_KeyStr(Key, Shift);
	UnicodeString CmdStr = Key_to_CmdF(KeyStr);
	bool handled = true;

	//m
	if (is_Num0to9(KeyStr) || equal_ENTER(KeyStr)) {
		int idx = is_Num0to9(KeyStr)? ((KeyStr.ToIntDef(0) + 9)%10) : lp->ItemIndex;
		if (idx!=-1) {
			if (isSelDir) {
				PathName = lp->Items->Strings[idx];
				if (USAME_TS(ExtractFileName(PathName), "..")) 
					PathName = get_parent_path(ExtractFilePath(PathName));
				PathName = IncludeTrailingPathDelimiter(PathName);
			}
			else if (isLibrary) {
				NyanFiForm->PopSelLibrary(lp->Items->Strings[idx], CurListTag, lp);
			}
			else {
				UnicodeString dnam = IncludeTrailingPathDelimiter(ComputerName) + lp->Items->Strings[idx];
				cursor_HourGlass();
				NyanFiForm->UpdateCurPath(IncludeTrailingPathDelimiter(dnam));
				cursor_Default();
			}
		}
		ModalResult = mrOk;
	}
	//pX؂ւ
	else if (PathTabControl->Visible &&
		equal_RIGHT(KeyStr) || contained_wd_i(_T("ToRight|ToParentOnRight"), CmdStr))
	{
		int idx = PathTabControl->TabIndex;
		if (idx<PathTabControl->Tabs->Count-1) {
			PathTabControl->TabIndex = idx + 1;
			PathTabControlChange(PathTabControl);
		}
	}
	else if (PathTabControl->Visible &&
		equal_LEFT(KeyStr) || contained_wd_i(_T("ToLeft|ToParentOnLeft"), CmdStr))
	{
		int idx = PathTabControl->TabIndex;
		if (idx>0) {
			PathTabControl->TabIndex = idx -1;
			PathTabControlChange(PathTabControl);
		}
	}
	//J[\ړ
	else if	(ExeCmdListBox(lp, CmdStr))		;
	//T[`
	else if (isSelDir && is_IniSeaKey(KeyStr))	ListBoxInitialSearch(lp, KeyStr, true);
	//
	else if (USAME_TI(CmdStr, "ReturnList"))	ModalResult = mrCancel;
	else handled = false;

	if (!is_DialogKey(Key) || handled) Key = 0;
}
//---------------------------------------------------------------------------
void __fastcall TNetShareDlg::ShareListBoxKeyPress(TObject *Sender, System::WideChar &Key)
{
	//CN^T[`
	if (_istalnum(Key)) Key = 0;
}
//---------------------------------------------------------------------------
void __fastcall TNetShareDlg::ShareListBoxDblClick(TObject *Sender)
{
	perform_Key_RETURN((TControl*)Sender);
}

//---------------------------------------------------------------------------
//UNCpXRs[
//---------------------------------------------------------------------------
void __fastcall TNetShareDlg::CopyUncItemClick(TObject *Sender)
{
	TListBox *lp = ShareListBox;
	if (lp->ItemIndex!=-1)
		Clipboard()->AsText = IncludeTrailingPathDelimiter(ComputerName) + lp->Items->Strings[lp->ItemIndex];
}
//---------------------------------------------------------------------------
void __fastcall TNetShareDlg::CopyUncAllItemClick(TObject *Sender)
{
	TListBox *lp = ShareListBox;
	std::unique_ptr<TStringList> lst(new TStringList());
	for (int i=0; i<lp->Count; i++)
		lst->Add(IncludeTrailingPathDelimiter(ComputerName) + lp->Items->Strings[i]);
	Clipboard()->AsText = lst->Text;
}
//---------------------------------------------------------------------------
void __fastcall TNetShareDlg::PopupMenu1Popup(TObject *Sender)
{
	CopyUncItem->Visible	= !isLibrary;
	CopyUncItem->Enabled	= !isLibrary && (ShareListBox->ItemIndex!=-1);
	CopyUncAllItem->Visible = !isLibrary;
	CopyUncAllItem->Enabled = ShareListBox->Count>0;
}

//---------------------------------------------------------------------------
void __fastcall TNetShareDlg::FormKeyDown(TObject *Sender, WORD &Key, TShiftState Shift)
{
	SpecialKeyProc(this, Key, Shift);
}
//---------------------------------------------------------------------------

